#import "CollectionArrayController.h"
#import "Bookmark.h"


NSString *CollectionMovedRowsType = @"COLLECTION_MOVED_ROWS_TYPE";
extern NSString *BookmarkMovedRowsType;

@implementation CollectionArrayController

- (void)awakeFromNib
{
	//hbOEhbv̐ݒ
    [_collectionTableView registerForDraggedTypes:
	[NSArray arrayWithObjects:CollectionMovedRowsType, BookmarkMovedRowsType, nil]];
}

/*
// ̊֐𗘗p͐Ȃ
- (BOOL)tableView:(NSTableView *)tableView writeRows:(NSArray *)rows
	toPasteboard:(NSPasteboard *)pboard {
    NSArray *typesArray = [NSArray arrayWithObjects:CollectionMovedRowsType, nil];

	[pboard declareTypes:typesArray owner:self];
    [pboard setPropertyList:rows forType:CollectionMovedRowsType];

	return YES;
}
*/

- (BOOL)tableView:(NSTableView *)tv writeRowsWithIndexes:(NSIndexSet *)rowIndexes toPasteboard:(NSPasteboard*)pboard
{
    NSArray *typesArray = [NSArray arrayWithObjects:CollectionMovedRowsType, nil];
	NSArray *rows;

	rows = [NSArray arrayWithObject:[NSNumber numberWithUnsignedInt:[rowIndexes firstIndex]]];	

	// rowIndexesnƃG[ôrows蒼Ă
	// ɗǂ@Ǝv܂
	[pboard declareTypes:typesArray owner:self];
    [pboard setPropertyList:rows forType:CollectionMovedRowsType];
	
	return YES;

}

- (NSDragOperation)tableView:(NSTableView *)tableView validateDrop:(id <NSDraggingInfo>)info 
	proposedRow:(int)row proposedDropOperation:(NSTableViewDropOperation)operation {
    
    NSDragOperation dragOperation = NSDragOperationCopy;
  
    if ([info draggingSource] == _collectionTableView) {
		dragOperation =  NSDragOperationMove;
		[tableView setDropRow:row dropOperation:NSTableViewDropAbove];
    } else if ([info draggingSource] == _bookmarkTableView) {
		dragOperation =  NSDragOperationMove;
		[tableView setDropRow:row dropOperation:NSTableViewDropOn];
	} else {
		[tableView setDropRow:row dropOperation:NSTableViewDropAbove];
	}

    return dragOperation;
}

- (BOOL)tableView:(NSTableView *)tableView acceptDrop:(id <NSDraggingInfo>)info 
	row:(int)row dropOperation:(NSTableViewDropOperation)operation {
	NSArray *rows;
	unsigned int originRow, originBookmarkRow;
	id object, originObject, originBookmark, originBookmarks;
    NSArray *objects;
	Bookmark *bookmark;
	BOOL flag;

	flag = YES;
	objects = [self arrangedObjects];


    if ([info draggingSource] == _collectionTableView) {
	// e[u̍s̓ւ
		rows = [[info draggingPasteboard] propertyListForType:CollectionMovedRowsType];
		// ̍s
//		originRow = [[rows objectAtIndex:0] intValue];	
		originRow = [[rows objectAtIndex:0] unsignedIntValue];	

		object = [objects objectAtIndex:originRow];
		if (originRow > row) {
			[self removeObjectAtArrangedObjectIndex:originRow];
			[self insertObject:object atArrangedObjectIndex:row];
//			[self setSelectionIndex:row];
		} else {
			[self removeObjectAtArrangedObjectIndex:originRow];
			[self insertObject:object atArrangedObjectIndex:row-1];
//			[self setSelectionIndex:row-1];
		}

	} else if ([info draggingSource] == _bookmarkTableView) {
		// ubN}[Nړ
		rows = [[info draggingPasteboard] propertyListForType:BookmarkMovedRowsType];

		object = [objects objectAtIndex:row]; 

		originRow = [self selectionIndex];
		originObject = [objects objectAtIndex:originRow]; 

		if (originRow != row) {
			originBookmarkRow = [[rows objectAtIndex:0] unsignedIntValue];	
			originBookmarks = [originObject valueForKey:@"bookmarks"];
			originBookmark = [originBookmarks objectAtIndex:originBookmarkRow];

			bookmark = [[Bookmark alloc] init];
			[bookmark setValue:[originBookmark valueForKeyPath:@"properties.title"] forKeyPath:@"properties.title"];
			[bookmark setValue:[originBookmark valueForKeyPath:@"properties.date"] forKeyPath:@"properties.date"];
			[bookmark setValue:[originBookmark valueForKeyPath:@"properties.url"] forKeyPath:@"properties.url"];
			[bookmark setValue:[originBookmark valueForKeyPath:@"properties.comment"] forKeyPath:@"properties.comment"];

			[[object valueForKey:@"bookmarks"] addObject:bookmark];

//			[originBookmarks removeObjectAtIndex:originBookmarkRow];
			[_arrayBookmarksController removeObjectAtArrangedObjectIndex:originBookmarkRow];
		} else {
		// RNVe[u̓ʒuBookmarkRs[łȂB
			flag = NO;
		}
	}

	return flag;
}

#pragma mark -
#pragma mark === delegate ====

- (BOOL)tableView:(NSTableView *)aTableView shouldSelectTableColumn:(NSTableColumn *)aTableColumn {
	return NO;
}


@end
