//
//  Controller.m
//  YKBookmarks
//
//  Created by KOYAMA Yoshiaki on Thu Feb 10 2005.
//  Copyright (c) 2005 KOYAMA Yoshiaki. All rights reserved.
//

#import "Controller.h"
#import "Bookmark.h"

@implementation Controller

- (void)awakeFromNib {
	NSFileManager *manager = [NSFileManager defaultManager];
	NSString *filePath;
	id content;
	NSUserDefaultsController *defaultsController;
	id values;
	id value;
	NSFont *aFont, *bFont;
	int i;
	NSData *data;
	NSString *key;

	// ݒEBhE𒆉Ɉړ
	[_preferencesWindow center];

	defaultsController = [NSUserDefaultsController sharedUserDefaultsController];
	aFont = [NSFont fontWithName:@"HiraKakuPro-W3" size:10];
	// l̐ݒ
	//[defaultsController setInitialValues:dictionary];
	// gׂłB
	
	values = [defaultsController values];

	for (i=0; i<11; i++) {
		key = [self defaultFontKey:i];
		value = [values valueForKey:key];
		
		if (value != nil) {
			// ݒ̃tHg̃^CgύX
			bFont = [NSUnarchiver unarchiveObjectWithData:value];
			[self setTitleButton:i :bFont];
		} else {
			// ݒ̃tHg̃^CgƏl̐ݒ
			data = [NSArchiver archivedDataWithRootObject:aFont];
			[values setValue:data forKey:[self defaultFontKey:i]];
			[self setTitleButton:i :aFont];
		}
	}

	// f[^̓ǂݍ
	filePath = NSHomeDirectory();
	filePath = [filePath stringByAppendingPathComponent:@"Documents/YKBookmarksDatabase"];

	if ([manager fileExistsAtPath:filePath] == YES) {		
		content = [NSKeyedUnarchiver unarchiveObjectWithFile:filePath];
		// f[^[Rg[ɐݒ
		[_objectController setContent:content];
	}

}


// vOȈ
- (NSApplicationTerminateReply)applicationShouldTerminate:(NSApplication *)sender {
	NSString *filePath;

	filePath = NSHomeDirectory();
	filePath = [filePath stringByAppendingPathComponent:@"Documents/YKBookmarksDatabase"];

	// t@CɃf[^ۑ
	[NSKeyedArchiver archiveRootObject:[_objectController content] toFile:filePath];

	return NSTerminateNow;
}

// EBhEƂ̏
- (BOOL)windowShouldClose:(id)sender {
	[NSApp terminate:self];
    return YES;
}

// IURL̃EFuuEŰN
- (IBAction)selectButton:(id)sender {
	NSWorkspace *wspace = [NSWorkspace sharedWorkspace];
	NSURL *url;
	NSString *urlString;
	Bookmark *bookmark;
	NSArray *array;

	array = [_arrayBookmarksController selectedObjects];

	bookmark = [array objectAtIndex:0];
	urlString = [bookmark valueForKeyPath:@"properties.url"];

	if (urlString != nil) {
		url = [NSURL URLWithString:urlString];
		[wspace openURL:url];
	}
}

// ׂĂURLEFuuEUŊJ
- (IBAction)allButton:(id)sender {
	NSWorkspace *wspace = [NSWorkspace sharedWorkspace];
	NSURL *url;
	NSString *urlString;
	Bookmark *bookmark;
	NSArray *array;
	int i;

	array = [_arrayBookmarksController arrangedObjects];

	for (i=0; i<[array count]; i++) {
		bookmark = [array objectAtIndex:i];

		urlString = [bookmark valueForKeyPath:@"properties.url"];

		if (urlString != nil) {
			url = [NSURL URLWithString:urlString];
			[wspace openURL:url];
		}
	}
}


// ݒ̃tHg^Cgݒ
- (void)setTitleButton:(int)tag :(NSFont *)font {
	NSString *title;

	title = [NSString stringWithFormat: @"%@ %.1f pt", [font displayName], [font pointSize]]; 

	// 炩NSButtontagݒ肵Ă
	switch (tag) {
		case 0:
			[_collectionTitleButton setTitle:title];
		break;
		case 1:
			[_bookmarkTitleButton setTitle:title];
		break;
		case 2:
			[_bookmarkUrlButton setTitle:title];
		break;
		case 3:
			[_bookmarkDateButton setTitle:title];
		break;
		case 4:
			[_InputTitleButton setTitle:title];
		break;
		case 5:
			[_InputUrlButton setTitle:title];
		break;
		case 6:
			[_InputCommentButton setTitle:title];
		break;
		case 7:
			[_detailTitleButton setTitle:title];
		break;
		case 8:
			[_detailUrlButton setTitle:title];
		break;
		case 9:
			[_detailDateButton setTitle:title];
		break;
		case 10:
			[_detailCommentButton setTitle:title];
		break;
	}
}

// tagL[𓱂o
- (NSString *)defaultFontKey:(int)tag {
	NSString *keyStr;

	switch (tag) {
		case 0:
			keyStr = @"collectionTitleFont";
		break;
		case 1:
			keyStr = @"bookmarkTitleFont";
		break;
		case 2:
			keyStr = @"bookmarkUrlFont";
		break;
		case 3:
			keyStr = @"bookmarkDateFont";
		break;
		case 4:
			keyStr = @"inputTitleFont";
		break;
		case 5:
			keyStr = @"inputUrlFont";
		break;
		case 6:
			keyStr = @"inputCommnentFont";
		break;
		case 7:
			keyStr = @"detailTitleFont";
		break;
		case 8:
			keyStr = @"detailUrlFont";
		break;
		case 9:
			keyStr = @"detailDateFont";
		break;
		case 10:
			keyStr = @"detailCommentFont";
		break;
		default:
			keyStr = @"";
		break;
	}

	return keyStr;
}			

// ݒ̃tHgύXANV
- (IBAction)prefFontButton:(id)sender {
	NSUserDefaultsController *defaultsController;	
	NSFontManager *manager;
	id values;
	id value;
	NSFont *aFont;
	
	// ܂芴SȂA{^̃^OۑĂ
	_tagFont = [sender tag];

	manager = [NSFontManager sharedFontManager];
	defaultsController = [NSUserDefaultsController sharedUserDefaultsController];
	
	values = [defaultsController values];
	value = [values valueForKey:[self defaultFontKey:[sender tag]]];
		
	if (value != nil) {
		aFont = [NSUnarchiver unarchiveObjectWithData:value];
	} else {
		aFont = [NSFont fontWithName:@"HiraKakuPro-W3" size:10];
	}

	[manager setAction:@selector(didChangeFont:)];

	[manager setSelectedFont:aFont isMultiple: NO];
    [manager orderFrontFontPanel: self];

}

// tHgύXƌĂ΂鏈
- (NSFont *)didChangeFont:(id)sender {
	NSUserDefaultsController *defaultsController;	
	NSFontManager *manager;
	id values;
	id value;
	NSFont *aFont, *newFont;
	NSData *data;

	manager = [NSFontManager sharedFontManager];
	defaultsController = [NSUserDefaultsController sharedUserDefaultsController];
	
	values = [defaultsController values];
	value = [values valueForKey:[self defaultFontKey:_tagFont]];
		
	if (value != nil) {
		aFont = [NSUnarchiver unarchiveObjectWithData:value];
	} else {
		aFont = [NSFont fontWithName:@"HiraKakuPro-W3" size:10];
	}

    newFont = [sender convertFont: aFont];

	data = [NSArchiver archivedDataWithRootObject:newFont];
	[values setValue:data forKey:[self defaultFontKey:_tagFont]];
	[self setTitleButton:_tagFont :newFont];

	return newFont;
}
@end
